%define name repoman
%define version 2.0.38
%define unmangled_version 2.0.38
%define unmangled_version 2.0.38
%define release 1

Summary: Manage artifact repositories
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
Source0: %{name}-%{unmangled_version}.tar.gz
License: GPLv3
Group: Development/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix: %{_prefix}
BuildArch: noarch
Vendor: oVirt Infrastructure/CI team <infra@ovirt.org>

%if ( 0%{?fedora} && 0%{?fedora} <= 25 ) || 0%{?rhel} == 6
Requires: python-argparse
%endif


%if 0%{?fedora} >= 1
Requires: python-pexpect
%else
Requires: pexpect
%endif


%if ( 0%{?fedora} && 0%{?fedora} <= 24 ) || 0%{?rhel} == 6
Requires: koji
%else
Requires: python-koji
%endif


%if 0%{?rhel} == 6
Requires: python-crypto
%else
Requires: python-cryptography
%endif


%if 0%{?fedora} || 0%{?rhel} >= 7
Requires: rpm-sign
%endif

Url: https://gerrit.ovirt.org/#/admin/projects/repoman
BuildRequires:python-dulwich
BuildRequires:python-pbr
Requires:createrepo_c
Requires:pyOpenSSL
Requires:python-setuptools
Requires:rpm-python
Requires:python-six
Requires:python-urllib3
Requires:python-requests
Requires:python-gnupg

%description
Development Environment Setup
==============================

To run the tests you need to have installed in your system a reasonable
new version of 'tox' and the required project dependencies that are
not available in PyPI.

See project's Dockerfile or requirements.txt to get idea which distribution
packages are needed. The list is created and maintained for Fedora or CentOS
with EPEL enabled.

Building and Running Tests
===========================

To build and run unit tests, run 'tox' from the top dir of the project::

    tox

There is also a functional test suite that can be run by specifying additional
'tox' environment parameter::

    tox -e functional

Building the Documentation
===========================

To build the docs, you can use 'docs' environment::

    tox -e docs

That will leave the docs under the path ``docs/_build/html/index.html``

Docker Development Image
=========================

This project requires a set of dependencies to be installed on a system. To help
with that for development there is a pre-built docker image available based
on the CentOS 7 official image. The development image includes everything
necessary to build repoman, run unit and functional tests and generate docs.

By default, the container will cd to /mnt directory where it expects the root of
repoman source code tree to be mounted, but will not run any command (there is
no entry point explicitly defined). Also it does not require root privileges and
is convenient to run under your UID, so you can use your working tree.

E.g. to run just 'tox' you can use::

    sudo docker run -v /path/to/repoman/source:/mnt -u $UID -t -i marchukov/repoman-tox-env-centos7 tox

You can pass 'tox' parameters to the container as usual, e.g. to run the
functional test suite::

    sudo docker run -v /path/to/repoman/source:/mnt -u $UID -t -i marchukov/repoman-tox-env-centos7 tox -e functional

Since each run will create a new container, when debugging requires multiple
runs, it is convenient to reuse a single container with an interactive shell::

    sudo docker run -v /path/to/repoman/source:/mnt -u $UID -t -i marchukov/repoman-tox-env-centos7 bash

This will give you a shell and you can then run 'tox' there or do whatever else
is necessary.



%prep
%setup -n %{name}-%{unmangled_version} -n %{name}-%{unmangled_version}

%build
python setup.py build

%install
python setup.py install --single-version-externally-managed -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES

%clean
rm -rf $RPM_BUILD_ROOT

%files -f INSTALLED_FILES
%defattr(-,root,root)
